<?php

defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @version 2.0 $Id: mosimage.php,v 1.13 2010-11-18 19:15:37 harry Exp $
 * @package Joomla
 * @subpackage H2N Mosimage Plugin
 * @copyright (C) 2010 Harry Klein - www.joomla-hklein.de
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license GNU/GPL, see LICENSE.php
 *
 * H2N Mosimage Plugin is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Mosimage Plugin is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */



jimport('joomla.event.plugin');

class plgContentMosimage extends JPlugin {
	
	const IMAGE_FILENAME = 0;
	const IMAGE_ALIGN = 1;
	const ALT_TEXT = 2;
	const BORDER_WDTH = 3;
	const CAPTION = 4;
	const CAPTION_POSITION = 5;
	const CAPTION_ALIGN = 6;
	const CAPTION_WIDTH = 7;
	
	public function plgContentMosimage(&$subject, $config = null){
		parent::__construct($subject, $config);
		$this->loadLanguage( 'plg_content_mosimage', JPATH_ADMINISTRATOR);
	}

	/** 
	 */
	private function isRowOnFrontpage(&$row){
		$isFrontpage = 1;
		// empierisch ermmitelt
		if (isset ($row->parameters)){
			$isFrontpage = 0; 
		}
		// $inFrontpage = (JRequest::getCmd( 'view' ) == 'frontpage') == true? 1:0;
		return $isFrontpage;
	}
	
	/**
	 */
	public function onPrepareContent(&$row, &$params, $page=0 ) {
		// simple performance check to determine whether bot should process further
		if ( strpos( $row->text, 'mosimage' ) === false ) {
			return true;
		}
	
		$regex = '/{mosimage\s*.*?}/i';
	
		if (!JPluginHelper::isEnabled('content', 'mosimage')) {
			$row->text = preg_replace( $regex, '', $row->text );
			return true;
		}
	
		$pageParams = new JParameter($row->attribs);
		$globalParams = clone($params);
		$globalParams->merge($pagaParams);
		
		//count how many {mosimage} are in introtext if it is set to hidden.
		$introCount=0;
		if ( ! $globalParams->get('show_intro') &&  ! $this->isRowOnFrontpage($row)) {
			preg_match_all( $regex, $row->introtext, $matches );
			$introCount = count ( $matches[0] );
		}
	
		// find all instances of mambot and put in $matches
		preg_match_all( $regex, $row->text, $matches );
	
		// Number of mambots
		$count = count( $matches[0] );
	
		// mambot only processes if there are any instances of the mambot in the text
		if ( $count ) {
						
			$configMd5=md5($this->params->toString());
			$botMtGlobals['quality'] = $this->params->get('quality', 80);
			$botMtGlobals['scramble'] = $this->params->get('scramble', 'off');
			$botMtGlobals['thumb_width'] = $this->params->get('thumb_width', 150);
			$botMtGlobals['thumb_height'] = $this->params->get('thumb_height', 100);
			$botMtGlobals['full_width'] = $this->params->get('full_width', 800);
			$botMtGlobals['full_height'] = $this->params->get('full_height', 600);
			$botMtGlobals['full_caption'] = $this->params->get('full_caption', 1);
			
			$botMtGlobals['transparency_type'] = $this->params->get('transparency_type', 'alpha');
			$botMtGlobals['transparency'] = $this->params->get('transparency', 25);
			$botMtGlobals['transparent_color'] = $this->params->get('transparent_color','#000000');
			$botMtGlobals['watermark_top'] = $this->params->get('watermark_top', '');
			$botMtGlobals['watermark_left'] = $this->params->get('watermark_left', '');
			$botMtGlobals['watermark_file'] = $this->params->get('watermark_file', '');
			$botMtGlobals['watermark'] = $this->params->get('watermark', 0);
			$botMtGlobals['image_proportions'] = $this->params->get('image_proportions', 'bestfit');
			$botMtGlobals['maxResizeImagePerRequest'] = $this->params->get('maxResizeImagePerRequest', 10);
			
			$document=& JFactory::getDocument();
			if(isset($_COOKIE['botmtscreenres'])){
	    		$botMtGlobals['screenres'] = explode('x', $_COOKIE['botmtscreenres']);
			} elseif(strpos($botMtGlobals['full_width'], '%') || strpos($botMtGlobals['full_height'], '%')) {
	        	$document->addScriptDeclaration('document.cookie= "botmtscreenres=" + screen.width+"x"+screen.height;');
	   		} 
	
			$this->params->def( 'padding' );
			$this->params->def( 'margin' );
			$this->params->def( 'link', 0 );
	
			$images = $this->processImages( $row, $this->params, $botMtGlobals, $introCount );
	
			// store some vars in globals to access from the replacer
			$GLOBALS['botMosImageCount'] 	= 0;
			$GLOBALS['botMosImageParams'] 	=& $this->params;
			$GLOBALS['botMosImageArray'] 	=& $images;
			//$GLOBALS['botMosImageArray'] 	=& $combine;
	
			// perform the replacement
			$row->text = preg_replace_callback( $regex, 'botMosImage_replacer', $row->text );
	
			// clean up globals
			unset( $GLOBALS['botMosImageCount'] );
			unset( $GLOBALS['botMosImageMask'] );
			unset( $GLOBALS['botMosImageArray'] );
			unset( $GLOBALS['botJosIntroCount'] );
	
			$lightboxType = $this->params->get('lightbox-type', 'lightbox2');
			switch($lightboxType){
				case 'lightbox2':
					$baseUrl = JURI::base().'plugins/content/mosimage/lightbox';
					$document->addScript($baseUrl .'/js/prototype.js');	
					$document->addScript($baseUrl .'/js/scriptaculous.js?load=effects,builder');
					$document->addScript($baseUrl .'/js/lightbox.js');
					$document->addStyleSheet($baseUrl.'/css/lightbox.css');
					break;
				case 'other_lightbox2':
					break;
				case 'sige_shadowbox':
					$baseUrl = JURI::base().'plugins/content/plugin_sige';
					$document->addScript($baseUrl .'/shadowbox.js');
					$document->addStyleSheet($baseUrl.'/shadowbox.css');
					$document->addScriptDeclaration('Shadowbox.init();');
					break;		
				case 'sige_slimbox':
					$baseUrl = JURI::base().'plugins/content/plugin_sige';
					$document->addScript($baseUrl .'/sige.css');
					$document->addScript($baseUrl .'/mootools.js');
					$document->addScript($baseUrl .'/slimbox.js');
					$document->addStyleSheet($baseUrl.'/slimbox.css');
					break;
			}
			$database =& JFactory::getDBO();
			return true;
		}
	}
	
	private function processImages ( &$row, &$params, &$botMtGlobals, &$introCount ) {
		$images 		= array();
	
		// split on \n the images fields into an array
		$row->images 	= explode( "\n", $row->images );
		$total 			= count( $row->images );
		$start = $introCount;
		for ( $i = $start; $i < $total; $i++ ) {
			$img = trim( $row->images[$i] );
	
			// split on pipe the attributes of the image
			if ( $img ) {
				$attrib = explode( '|', trim( $img ) );
				// $attrib[0] image name and path from /images/stories
	
				// $attrib[1] alignment
				if ( !isset($attrib[self::IMAGE_ALIGN]) || !$attrib[self::IMAGE_ALIGN] ) {
					$attrib[self::IMAGE_ALIGN] = '';
				}
	
				// $attrib[2] alt & title
				if ( !isset($attrib[self::ALT_TEXT]) || !$attrib[self::ALT_TEXT] ) {
					$attrib[self::ALT_TEXT] = 'Image';
				} else {
					$attrib[self::ALT_TEXT] = htmlspecialchars( $attrib[self::ALT_TEXT] );
				}
	
				// $attrib[3] border
				if ( !isset($attrib[self::BORDER_WDTH]) || !$attrib[self::BORDER_WDTH] ) {
					$attrib[self::BORDER_WDTH] = 0;
				}
	
				// $attrib[4] caption
				if ( !isset($attrib[self::CAPTION]) || !$attrib[self::CAPTION] ) {
					$attrib[self::CAPTION]	= '';
					$border 	= $attrib[self::BORDER_WDTH];
				} else {
					$border 	= 0;
				}
	
				// $attrib[5] caption position
				if ( !isset($attrib[self::CAPTION_POSITION]) || !$attrib[self::CAPTION_POSITION] ) {
					$attrib[self::CAPTION_POSITION] = '';
				}
	
				// $attrib[6] caption alignment
				if ( !isset($attrib[self::CAPTION_ALIGN]) || !$attrib[self::CAPTION_ALIGN] ) {
					$attrib[self::CAPTION_ALIGN] = '';
				}
	
				// $attrib[7] width
				if ( !isset($attrib[self::CAPTION_WIDTH]) || !$attrib[self::CAPTION_WIDTH] ) {
					$attrib[self::CAPTION_WIDTH] 	= '';
					$width 		= '';
				} else {
					$width 		= ' width: '. $attrib[self::CAPTION_WIDTH] .'px;';
				}
	
				// image size attibutes
				$size = '';
				if ( function_exists( 'getimagesize' ) ) {
					$size 	= @getimagesize( JPATH_SITE .'/images/stories/'. $attrib[self::IMAGE_FILENAME] );
					if (is_array( $size )) {
						$size = ' width="'. $size[0] .'" height="'. $size[1] .'"';
					}
				}
	
				$filename = JPATH_SITE .DS.'images' . DS .'stories'. DS . $attrib[self::IMAGE_FILENAME];

				$thumb_width = $botMtGlobals['thumb_width'];
				$thumb_heigth = $botMtGlobals['thumb_height'];
				$full_width = $botMtGlobals['full_width'];
				$full_height = $botMtGlobals['full_height'];
				$full_caption = $botMtGlobals['full_caption'];
				
				$xpos=strpos($full_width, '%');
				$ypos=strpos($full_height, '%');
				if($xpos || $ypos ) {			 	
	    			if(!isset($screenres)) {
	    				$screenres = array(1024, 768);
	    			}
	    			if($xpos) {
	    				$full_width = $screenres[0] * substr($full_width, 0, $xpos) / 100;
	    			}
	    			if($ypos) {
	    				$full_height = $screenres[1] * substr($full_height, 0, $ypos) / 100;
	    			}
	   			}
	   			
				$watermarkfile = JPATH_SITE .DS.'images' . DS .'stories'. DS . $botMtGlobals['watermark_file'];
				
				$thumbProperties = $this->botmt_thumbnail($botMtGlobals, $filename, $thumb_width, $thumb_heigth);
				$imageProperties = $this->botmt_thumbnail($botMtGlobals, $filename, $full_width, $full_height, true , 0xFFFFFF, $watermarkfile );
				
				if (!$thumbProperties || !$imageProperties){
					return;
				}
				
				$thumbSize = ' width="'. $thumbProperties->getWidth() .'" height="'. $thumbProperties->getHeight() .'"';
				
				$lightboxType = $params->get('lightbox-type', 'lightbox2');
				switch($lightboxType){
					case 'lightbox2':
					case 'other_lightbox2':
						$rel='lightbox[roadtrip]'; 
						$class='';
						break;
					case 'sige_shadowbox':
						$rel='lyteshow.sig0';
						$class=' class="sige_css_image" ';
						break;		
					case 'sige_slimbox':
						$rel='lightbox.sig0';
						$class=' class="sige_css_image" ';
						break;
				}
				$image = '<a href="'. $imageProperties->getUrl() .'" rel="'.$rel.'" '. $class .' title="' . ($full_caption ? $attrib[self::CAPTION]:'') . '"><img src="'. $thumbProperties->getUrl()  .'"'. $thumbSize;
				
				if ( !$attrib[self::CAPTION] || ! $params->def( 'thumb_caption' ) ) {
					if ($attrib[self::IMAGE_ALIGN] == 'left' OR $attrib[self::IMAGE_ALIGN] == 'right') {
						$image .= ' style="float: '. $attrib[self::IMAGE_ALIGN] .';"';
					} else {
						$image .= $attrib[self::IMAGE_ALIGN] ? ' align="middle"' : '';
					}
				}
				$image .=' hspace="6" alt="'. $attrib[self::ALT_TEXT] .'" title="'. $attrib[self::ALT_TEXT] .'" border="'. $border .'" /></a>';
				// assemble caption - if caption detected
				$caption = '';
				if ( $attrib[self::CAPTION] &&  $params->def( 'thumb_caption' )) {
					$caption = '<div class="mosimage_caption"';
					if ( $attrib[self::CAPTION_ALIGN] ) {
						$caption .= ' style="text-align: '. $attrib[self::CAPTION_ALIGN] .';"';
						$caption .= ' align="'. $attrib[self::CAPTION_ALIGN] .'"';
					}
					$caption .= '>';
					$caption .= $attrib[self::CAPTION];
					$caption .= '</div>';
				}
	
				// final output
				if ( $attrib[self::CAPTION] &&  $params->def( 'thumb_caption' )) {
					// initialize variables
					$margin  		= '';
					$padding 		= '';
					$float			= '';
					$border_width 	= '';
					$style			= '';
					if ( $params->def( 'margin' ) ) {
						$margin 		= ' margin: '. $params->def( 'margin' ).'px;';
					}
					if ( $params->def( 'padding' ) ) {
						$padding 		= ' padding: '. $params->def( 'padding' ).'px;';
					}
					if ( $attrib[self::IMAGE_ALIGN] ) {
						$float 			= ' float: '. $attrib[self::IMAGE_ALIGN] .';';
					}
					if ( $attrib[self::BORDER_WDTH] ) {
						$border_width	= ' border-width: '. $attrib[self::BORDER_WDTH] .'px;';
					}
	
					if ( $params->def( 'margin' ) || $params->def( 'padding' ) || $attrib[self::IMAGE_ALIGN] || $attrib[self::BORDER_WDTH] ) {
						$style = ' style="'. $border_width . $float . $margin . $padding . $width .'"';
					}
	
					$img = '<div class="mosimage" '. $style .' align="center">';
	
					// display caption in top position
					if ( $attrib[self::CAPTION_POSITION] == 'top' && $caption ) {
						$img .= $caption;
					}
	
					$img .= $image;
	
					// display caption in bottom position
					if ( $attrib[self::CAPTION_POSITION] == 'bottom' && $caption ) {
						$img .= $caption;
					}
					$img .='</div>';
				} else {
					$img = $image;
				}
	
				$images[] = $img;
			}
		}
		return $images;
	}

	private function botmt_thumbnail(&$botMtGlobals,$filename, $width, $height, $chageProportions=false , $bgcolor = 0xFFFFFF, $watermarkfile = '') {
		static $countGenerateImage;
		
		if (!isset($countGenerateImage)){
			$countGenerateImage = 0;
		}
		static $disablegifwarning, $disablepngwarning, $disablejpgwarning, $disablepermissionwarning;
		
		$relPathToCache = 'cache' . DS . 'mosimage-cache';
		$cachepath = JPATH_SITE. DS . $relPathToCache; 
		if (!JFolder::exists($cachepath)){
			JFolder::create($cachepath);
		}
	
		$temp = pathinfo($filename);
		$ext = $temp['extension']; //todo: check filename here
		$alt_filename = '';
	
		$size = @getimagesize($filename);
		if(!$size) {
			JError::raiseWarning(200,"There was a problem loading image [$filename]");
			return false;
		}
		$origw = $size[0];
		$origh = $size[1];
		if($alt_filename && ($origw<$width || $origh<$height)) {
			$width = $origw;
			$height = $origh;
		}
		
		if ($botMtGlobals['watermark'] && $watermarkfile){
			$watermark = 1;
		} else {
			$watermark = 0;
		}
		if ($chageProportions) {
			$proportion = $botMtGlobals['image_proportions'];
		}
		else {
			$proportion='bestfit';
		}
		if($origw<$width && $origh<$height) {
			$proportion='fill';
		}
		
		if($width || $height) {
			$prefix = substr($proportion,0,1) . ".$width.$height.$bgcolor.$watermark.";
		}
		else {
			$prefix = "$watermark.";
		}
		$thumb_file = $prefix . str_replace(array(':','/','\\'),  '.' ,substr($filename,strlen(JPATH_SITE)+8));
		$thumb_file = MosimageThumbnail::calcFilename($thumb_file, $ext, $botMtGlobals['scramble']);
		$thumbname =  $cachepath . DS  . $thumb_file;
		if(file_exists($thumbname))
		{
			$size = @getimagesize($thumbname);
			if($size) {
				$width = $size[0];
				$height = $size[1];
			}
		}
		else {		
			if(!($width || $height)) { // Both sides zero
				$width = $origw;
				$height = $origh;
				$proportion='stretch';
			}
			elseif(!($width && $height)){ // One of the sides zero
				$proportion = 'bestfit';
			}
			$newheight = $height; $newwidth = $width;
			$dst_x = $dst_y = $src_x = $src_y = 0;
			if((($origw < $origh && $width < $height) || ($origw >= $origh && $width <= $height)) && $width != 0 || $height == 0)
			switch($proportion) {
				case 'fill':
					$newheight =  $origh/$origw*$width;
					$dst_y = ($height - $newheight)/2;
					break;
				case 'crop':
					$temph = $origw;
					$origw = $origh / $newheight * $newwidth;
					$src_x = ($temph-$origw)/2;
					break;
				case 'bestfit':
					$newheight = $height = round($width / ($origw / $origh));
			}
			else
			switch($proportion) {
				case 'fill':
					$newwidth =  $origw/$origh*$height;
					$dst_x = ($width - $newwidth)/2;
					break;
				case 'crop':
					$temph = $origh;
					$origh = $origw * $newheight / $newwidth;
					$src_y = ($temph-$origh)/2;
					break;
				case 'bestfit':
					$newwidth = $width = round($height * ($origw / $origh));
			}
			if ($countGenerateImage >  $botMtGlobals['maxResizeImagePerRequest']) {
				$mosimageThumbnail = new MosimageThumbnail($relPathToCache);
				return $mosimageThumbnail->generatePlaceHolder($width, $height, $botMtGlobals['scramble']);
			}
			$countGenerateImage++;
			
			switch(strtolower($ext)) {
				case 'png':
					if(!function_exists("imagecreatefrompng")) {
						if(!$disablepngwarning) {
							JError::raiseWarning(200,'PNG is not supported on this server.');
						}
						$disablepngwarning = true;
						return false;
					}
					else {
						$src_img = imagecreatefrompng($filename);
						$imagefunction = "imagepng";
					}
					break;
				case 'gif':
					if(!function_exists("imagecreatefromgif")) {
						if(!$disablegifwarning) {
							JError::raiseWarning(200,'GIF is not supported on this server.');
						}
						$disablegifwarning = true;
						return false;
					}
					else {
						$src_img = imagecreatefromgif($filename);
						$imagefunction = "imagegif";
					}
					break;
				default:
					if(!function_exists("imagecreatefromjpeg")) {
						if(!$disablejpgwarning) {
							JError::raiseWarning(200,'JPG is not supported on this server.');
						}
						$disablejpgwarning = true;
						return false;
					}
					else {
						$src_img = imagecreatefromjpeg($filename);
						$imagefunction = "imagejpeg";
					}
			}
			$dst_img = ImageCreateTrueColor($width, $height);
			imagefill( $dst_img, 0,0, $bgcolor);
			imagecopyresampled($dst_img,$src_img, $dst_x, $dst_y, $src_x, $src_y, $newwidth,$newheight,$origw, $origh);
	
			if($watermarkfile && $watermark) {
				if($botMtGlobals['transparency_type'] == 'alpha') {
					$transcolor = FALSE;
				}
				else {
					$transcolor = $botMtGlobals['transparent_color'];
				}
				create_watermark($dst_img, $watermarkfile, $botMtGlobals['watermark_left'], $botMtGlobals['watermark_top'], $transcolor, $botMtGlobals['transparency']);
			}
			if($imagefunction=='imagejpeg') {
				$result = @$imagefunction($dst_img, $thumbname, $botMtGlobals['quality']);
			}
			else {
				$result = @$imagefunction($dst_img, $thumbname);
			}
			imagedestroy($src_img);
			if(!$result) {
				if(!$disablepermissionwarning) {
					JError::raiseWarning(200,"Could not create image: [$thumbname]. Check if you have write permissions in ·[$cachepath]");
				}
				$disablepermissionwarning = true;
			}
			else
			imagedestroy($dst_img);
		}
		$url = JRoute::_(JURI::base(). '/' . $relPathToCache . '/' . basename($thumbname));
		return new MosimageThumbPropertires($url, $width, $height);
	}
}

/**
 * Replaces the matched tags an image
 * @param array An array of matches (see preg_match_all)
 * @return string
 */
function botMosImage_replacer( &$matches ) {
	$i = $GLOBALS['botMosImageCount']++;

	return @$GLOBALS['botMosImageArray'][$i];
}

class MosimageThumbnail {
	
	private $cachepath;
	private $relPathToCache;
	
	public function __construct($relPathToCache){
		$this->relPathToCache = $relPathToCache;
		$this->cachepath = JPATH_SITE. DS . $relPathToCache; 
	}
	
	/** liefert Dateinamen für des Vorschau- bzw. Vollbild 
	 *
	 * @param String $thumb_file
	 * @param String $ext
	 * @param String $scramble md5,crc32 oder leer
	 * @return string|null*/
	
	static function calcFilename($thumb_file, $ext, $scramble){
		switch($scramble) {
			case 'md5': 
				return md5($thumb_file) . '.' . $ext; 
				break;
			case 'crc32': 
				return sprintf("%u", crc32($thumb_file)) . '.' . $ext;
				break;
			default:
				return $thumb_file;
		}
	}
	
	/**
	 * 
	 * Erzeugt das PlaceholderImage und liefert dessen URL, Höhe und Breite. 
	 * @param int $width
	 * @param int $height
	 * @param String $scramble 
	 * @return MosimageThumbPropertires
	 */
	function generatePlaceHolder($width, $height, $scramble){
		$document=& JFactory::getDocument();
		$language = $document->getLanguage();
		$thumb_file = MosimageThumbnail::calcFilename("$width.$height.$language.placeholder.jpg", 'jpg', $scramble);
		$thumbname =  $this->cachepath . DS  . $thumb_file;
		if(file_exists($thumbname)) {
			$size = @getimagesize($thumbname);
			if($size) {
				$width = $size[0];
				$height = $size[1];
				return new MosimageThumbPropertires($this->buildUrlToImage($thumbname), $width, $height);
			}
		}
		$placeholderImage = ImageCreateTrueColor($width, $height);
		imagefilledrectangle($placeholderImage, 2, 2, $width-3, $height-3, 0xeeeeee);
		$fontSize = 2;
		$string = JText::_('generate image');
		$textWidth = imagefontwidth($fontSize)*strlen($string);
		$center = ceil($width / 2);	
		$x = $center - (ceil($textWidth/2));
		$color = ImageColorAllocate ($placeholderImage, 0, 0, 0); 
		ImageString($placeholderImage, $fontSize, $x, 45, $string, $color); 
		$result = imagejpeg($placeholderImage, $thumbname, 80);	
		imagedestroy($placeholderImage);
		return new MosimageThumbPropertires($this->buildUrlToImage($thumbname), $width, $height);
	}
	
	private function buildUrlToImage($thumbname){
		return JURI::base(). '/' . $this->relPathToCache . '/' . basename($thumbname);
	}
	
}

class MosimageThumbPropertires {
	private $width;
	private $height;	
	private $url;
	
	function __construct($url, $width, $height){
		$this->url = $url;
		$this->width = $width;
		$this->height = $height;
	}
	
	function getWidth(){
		return $this->width;
	}
	
	function getHeight(){
		return $this->height;
	}
	
	function getUrl(){
		return $this->url;
	}
	
}

function create_watermark($sourcefile_id, $watermarkfile, $x, $y, $transcol = false, $transparency = 100) {
	static $disable_wm_ext_warning, $disable_wm_load_warning, $disable_alpha_warning;

	//Get the resource ids of the pictures
	$fileType = strtolower(substr($watermarkfile, strlen($watermarkfile)-3));
	switch($fileType) {
		case 'png':
			$watermarkfile_id = @imagecreatefrompng($watermarkfile);
			break;
		case 'gif':
			$watermarkfile_id = @imagecreatefromgif($watermarkfile);
			break;
		case 'jpg':
			$watermarkfile_id = @imagecreatefromjpeg($watermarkfile);
			break;
		default:
			$watermarkfile = basename($watermarkfile);
			if(!$disable_wm_ext_warning) {
				JError::raiseWarning(200,"You cannot use a [.$fileType] file ($watermarkfile) as a watermark");
			}
			$disable_wm_ext_warning = true;
			return false;
	}
	if(!$watermarkfile_id) {
		if(!$disable_wm_load_warning) {
			JError::raiseWarning(200,"There was a problem loading the watermark [$watermarkfile]");
		}
		$disable_wm_load_warning = true;
		return false;
	}
	@imageAlphaBlending($watermarkfile_id, false);
	$result = @imageSaveAlpha($watermarkfile_id, true);
	if(!$result) {
		if(!$disable_alpha_warning) {
			JError::raiseWarning(200, "Watermark problem: your server does not support alpha blending (requires GD 2.0.1+)");
		}
		$disable_alpha_warning = true;
		imagedestroy($watermarkfile_id);
		return false;
	}
	//Get the sizes of both pix
	$sourcefile_width=imageSX($sourcefile_id);
	$sourcefile_height=imageSY($sourcefile_id);
	$watermarkfile_width=imageSX($watermarkfile_id);
	$watermarkfile_height=imageSY($watermarkfile_id);
	if(!$x) {
		$dest_x = ( $sourcefile_width / 2 ) - ( $watermarkfile_width / 2 );
	}
	elseif($x>0) {
		$dest_x = $x;
	}
	else {
		$dest_x = $sourcefile_width - $watermarkfile_width + $x;
	}
	if(!$y) {
		$dest_y = ( $sourcefile_height / 2 ) - ( $watermarkfile_height / 2 );
	}
	elseif($y>0) {
		$dest_y = $y;
	}
	else {
		$dest_y = $sourcefile_height - $watermarkfile_height + $y;
	}
	// if a gif, we have to upsample it to a truecolor image
	if($fileType == 'gif') {
		// create an empty truecolor container
		$tempimage = imagecreatetruecolor($sourcefile_width, $sourcefile_height);
			
		// copy the 8-bit gif into the truecolor image
		imagecopy($tempimage, $sourcefile_id, 0, 0, 0, 0, $sourcefile_width, $sourcefile_height);
			
		// copy the source_id int
		$sourcefile_id = $tempimage;
	}
	if($transcol!==false) {
		imagecolortransparent($watermarkfile_id, $transcol); // use transparent color
		imagecopymerge($sourcefile_id, $watermarkfile_id, $dest_x, $dest_y, 0, 0, $watermarkfile_width, $watermarkfile_height, $transparency);
	}
	else {
		imagecopy($sourcefile_id, $watermarkfile_id, $dest_x, $dest_y, 0, 0, $watermarkfile_width, $watermarkfile_height); // True alphablend
	}
	imagedestroy($watermarkfile_id);

}

?>