<?php

defined('_JEXEC') or die( 'Restricted access' );

/**
 * @version 2.0 $Id: recursiveimagelist.php,v 1.5 2010-11-18 19:09:32 harry Exp $
 * @package Joomla
 * @subpackage H2N Plugin Mosimage
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Plugin Mosimage is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Plugin Mosimage is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport('joomla.filesystem.file');

class JElementRecursiveImageList extends JElement {
	var	$_name = 'RecursiveImageList';
	private $rootDir;

	public function __construct(){
		$this->rootDir = JPATH_SITE . DS . 'images'. DS . 'stories';
	}

	public function fetchElement($name, $value, &$node, $control_name) {
		$options = $this->readFileList($this->rootDir);
		return JHTML::_('select.genericlist',  $options, ''.$control_name.'['.$name.']', 'class="inputbox"', 'id', 'text', $value, $control_name.$name );
	}

	private function readFileList($path ) {
		$filter =  '^[^\.]' ; // show hidden files
		$recurse = true;
		$excludefiles = array();
		$excludeexts = array();
		$groupdirs = false;
		$filelist = JFolder::files($path, $filter, $recurse, true, $excludefiles);

		$files = array();
		if (!$groupdirs) {
			$files[0] = array();
		}
		$files[0][] = $this->getFile(null);
		$count = 0;
		while (list($i, $file) = each($filelist)) {
			$count++;
			if ($count > 500) break;
			if (in_array(JFile::getName($file), $excludefiles)) continue;
			if (in_array(JFile::getExt($file), $excludeexts)) continue;
			$file =& $this->getFile($file);
			if ($groupdirs) {
				if (!isset($files[$file->dirname])) {
					$files[$file->dirname] = array();
				}
				$files[$file->dirname][] = $file;
			} else {
				$files[0][] = $file;
			}
		}

		foreach($files as &$v) {
			$this->fileSort($v);
		}
		return $files[0];
	}

	private function &getFile($file){
		$obj = new JObject();
		if ($file != null){
			$obj->id = $this->stripPath($file,$this->rootDir);
			$obj->text = &$obj->id;
			$obj->name = basename($file);
			$obj->dirname = dirname($file);
		} else {
			$obj->id = '';
			$obj->text = '- '. JText::_('Select file') .' -';
			$obj->name = basename($file);
			$obj->dirname = dirname($file);
		}
		return $obj;
	}

	/**
	 * Strip given path from the start of the filename.
	 *
	 * @param String Filename to strip from.
	 * @param String Path to strip from start of filename.
	 * @return String Filename with $path stripped from start.
	 */
	private function stripPath(&$filename, &$path) {
		if (strpos($filename, $path) === 0) {
			return substr($filename, strlen($path) + 1);
		} else {
			return $filename;
		}
	}

	/**
	 */
	private function fileSort(&$array) {
		usort($array, array('JElementRecursiveImageList', 'compareFiles'));
	}

	private function compareFiles(&$a, &$b){
		$result = strnatcasecmp($a->dirname, $b->dirname);
		if ($result != 0) {
			return $result;
		}
		return strnatcasecmp($a->name, $b->name);
	}
}